using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_ServiciosWeb;
using Exferia_Aplicacion.Visualizacion;
using Exferia_General;
using Exferia_ServiciosWeb;
using Exferia_ServiciosWeb.ServiciosWeb;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace Test
{
    public partial class Form1 : Form
    {
        private string g_str_RUTA = Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\XML_DatosPrueba.xml";
        private string g_str_idUsuario = "";

        public Form1()
        {
            InitializeComponent();

            Variables.G_STR_CONEXION_BASEDATOS = "fff";

            if (!File.Exists(g_str_RUTA))
            {
                CrearXML();
            }
            else
            {
                Cargar_ValoresXML();

                lbl_Servidor.Text = Variables.G_STR_CONEXION_SERVIDOR;
                lbl_BaseDatos.Text = Variables.G_STR_CONEXION_BASEDATOS;
                lbl_Perfil.Text = g_str_idUsuario;

            }

            //Asignar Colores de Exferia ..................................................................
            Colores.G_COLOR_FONDO_BOTON = Color.Transparent;
            Colores.G_COLOR_PRINCIPAL_BASE = ColorTranslator.FromHtml("#A19CC3");
            Colores.G_COLOR_PRINCIPAL_OSCURO = ColorTranslator.FromHtml("#504888");
            Colores.G_COLOR_PRINCIPAL_ATENUADO = ColorTranslator.FromHtml("#CBC8DF");
            Colores.G_COLOR_PRINCIPAL_CLARO = ColorTranslator.FromHtml("#EDECF4");
            Colores.G_COLOR_PRINCIPAL_TRASLUCIDO = Color.FromArgb(50, 191, 186, 225);
            Colores.G_COLOR_SECUNDARIO_BASE = ColorTranslator.FromHtml("#FFF2C4");
            Colores.G_COLOR_SECUNDARIO_CLARO = ColorTranslator.FromHtml("#FFF9E1");
            Colores.G_COLOR_FONDO_BASE = ColorTranslator.FromHtml("#FFFFFF");
            Colores.G_COLOR_TEXTO_ESCRITO = ColorTranslator.FromHtml("#000000");
            Colores.G_COLOR_ATENCION = ColorTranslator.FromHtml("#c40909");

            Colores.G_COLOR_FONDO_BARRAPROGRESO_RELLENA = ColorTranslator.FromHtml("#504888");

            //Listados
            Colores.G_COLOR_LISTADO_FILTROS = Color.FromArgb(50, 161, 156, 195);
            Colores.G_COLOR_LISTADO_FILTROS_CONTROLESPERSONALIZADOS = Color.FromArgb(70, 161, 156, 195);

            //Conexion ...............................................................
            // Variables.G_STR_CONEXION_SERVIDOR = @"DESKTOP-KJVHQLH\SQLEXPRESS2014";
            //Variables.G_STR_CONEXION_SERVIDOR = @"1.trialia.es,42103";
            //Variables.G_STR_CONEXION_BASEDATOS = "SigmaERP2017";
            //Variables.G_STR_CONEXION_USUARIO = "sa";
            //Variables.G_STR_CONEXION_CLAVE = "SQL_Exferia";

            //Usuario Validado .......................................................
            INTERNO_UsuarioValidado_Modelo mdl_INTERNO_UsuarioValidado_Modelo = new INTERNO_UsuarioValidado_Modelo();
            mdl_INTERNO_UsuarioValidado_Modelo.id = long.Parse(g_str_idUsuario != "" ? g_str_idUsuario : "0");
            mdl_INTERNO_UsuarioValidado_Modelo.idPerfil = null;
            mdl_INTERNO_UsuarioValidado_Modelo.nombre = "Exferia";
            mdl_INTERNO_UsuarioValidado_Modelo.sincronizacionAthos = false;
            mdl_INTERNO_UsuarioValidado_Modelo.esSuperUsuario = false;

            Variables.G_MDL_USUARIOVALIDADO_MODELO = mdl_INTERNO_UsuarioValidado_Modelo;


            //Delegacion
            Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO = null;
            INTERNO_ValoresGenerales_Modelo mdl_INTERNO_ValoresGenerales_Modelo = Datos_Generales.GEN_ValoresGenerales_Obtener_Por_IdUsuario(Variables.G_MDL_USUARIOVALIDADO_MODELO.id);
            if (mdl_INTERNO_ValoresGenerales_Modelo != null)
            {
                mdl_INTERNO_ValoresGenerales_Modelo = Datos_Generales.GEN_EjerciciosActivos_Empresa_Validar(mdl_INTERNO_ValoresGenerales_Modelo, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO);
                if (mdl_INTERNO_ValoresGenerales_Modelo != null)
                {
                    Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO = mdl_INTERNO_ValoresGenerales_Modelo;
                }
            }
            Variables.G_DTT_FECHA_INICIAL_PORDEFECTO = DateTime.Now;

            //Cargar XML Configuracion pantallas
            Funciones_FicherosXML.CargarDatosXML_ConfiguracionPantallas();

            Datos_Generales.PRV_OpcionesDetalle_Cargar();
            
            Repintar.Empezar(this);

            Variables.G_PNL_PANTALLASEMPOTRADAS = pnl_Principal;
            Variables.G_EMS_CONTROL_MENUSUPERIOR = ex_msp_Menu;

            Datos_Generales.Permisos_Cargar();

        }

        private void btn_Abrir_Listado_Click(object sender, EventArgs e)
        {
            
        }

        private void btn_Abrir_Mantenimiento_Click(object sender, EventArgs e)
        {
            
        }

        private void btn_CodigoPrueba_Click(object sender, EventArgs e)
        {
            try
            {
                Licencia obj_ = new Licencia();
                INTERNO_ServicioWeb_Licencia_Modelo mdl_INTERNO_ServicioWeb_Licencia_Modelo= obj_.Validar_Licencia(5, "e1af22fb-6bd0-43eb-b79a-7baa657ef221");
            }
            catch (Control_Errores)
            { }
        }

        private void CrearXML()
        {
            FileStream fls_CrearFichero = null;
            try
            {
                //Creamos el fichero
                fls_CrearFichero = new FileStream(g_str_RUTA, FileMode.Create);

                fls_CrearFichero.Close();

                //Ahora crearemos la estructura del XML
                XmlDocument Documento = new XmlDocument();
                XmlNode xn_Declaration = Documento.CreateXmlDeclaration("1.0", "UTF-8", "yes");
                Documento.AppendChild(xn_Declaration);
                //Nodo Padre
                XmlNode xn_NodoPrincipal = Documento.CreateElement("Datos");
                Documento.AppendChild(xn_NodoPrincipal);
                //Nodos Hijos
                XmlNode xn_Servidor = Documento.CreateElement("servidor");
                XmlNode xn_BaseDatos = Documento.CreateElement("basedatos");
                XmlNode xn_Usuario = Documento.CreateElement("usuario");
                XmlNode xn_Clave = Documento.CreateElement("clave");
                XmlNode xn_Perfil = Documento.CreateElement("idusuario");

                xn_NodoPrincipal.AppendChild(xn_Servidor);
                xn_NodoPrincipal.AppendChild(xn_BaseDatos);
                xn_NodoPrincipal.AppendChild(xn_Usuario);
                xn_NodoPrincipal.AppendChild(xn_Clave);
                xn_NodoPrincipal.AppendChild(xn_Perfil);

                Documento.Save(g_str_RUTA);

                AbrirPantallaConexion();
            }
            catch (Exception)
            {

            }
        }

        private void Cargar_ValoresXML()
        {
            XmlDocument Documento = new XmlDocument();
            Documento.Load(g_str_RUTA);

            //Nodo principal 
            XmlNode obj_NodoPadre = Documento.GetElementsByTagName("Datos")[0];

            Variables.G_STR_CONEXION_SERVIDOR = obj_NodoPadre["servidor"].InnerText;
            Variables.G_STR_CONEXION_BASEDATOS = obj_NodoPadre["basedatos"].InnerText;
            Variables.G_STR_CONEXION_USUARIO = obj_NodoPadre["usuario"].InnerText;
            Variables.G_STR_CONEXION_CLAVE = obj_NodoPadre["clave"].InnerText;
            g_str_idUsuario = obj_NodoPadre["idusuario"].InnerText;

            if (Variables.G_STR_CONEXION_SERVIDOR.Equals("") || g_str_idUsuario.Equals(""))
            {
                AbrirPantallaConexion();
            }
        }

        private void btn_CambiarConexion_Click(object sender, EventArgs e)
        {
            AbrirPantallaConexion();
        }

        private void AbrirPantallaConexion()
        {
            Form2 frm_Conexion = new Form2(Variables.G_STR_CONEXION_SERVIDOR, Variables.G_STR_CONEXION_BASEDATOS, Variables.G_STR_CONEXION_USUARIO, Variables.G_STR_CONEXION_CLAVE, g_str_idUsuario);
            frm_Conexion.StartPosition = FormStartPosition.CenterParent;
            frm_Conexion.ShowDialog();
        }
    }
}
